APT-GET(8)

NOME
apt-get - strumento APT per la gestione dei pacchetti, interfaccia a riga di comando

SINOSSI

apt-get [-asqdyfmubV] [-o=stringa_config] [-c=file_config] [-t=rilascio_obiettivo] [-a=architettura] {update | upgrade | dselect-upgrade | dist-upgrade | install pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | remove pacch... | purge pacch... | source pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | build-dep pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | download pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | check | clean | autoclean | autoremove | {-v | --version} | {-h | --help}}

DESCRIZIONE

apt-get è lo strumento a riga di comando per gestire pacchetti e può essere considerato il «backend» dell'utente per altri strumenti che usano la libreria APT. Esistono diversi «frontend» per interfaccia, come aptitude(8), synaptic(8) e wajig(1).

A meno che non venga fornita l'opzione -h o --help, deve essere presente uno dei comandi seguenti.

update
    update è usato per sincronizzare nuovamente i file degli indici dei pacchetti dalle loro fonti. Gli indici dei pacchetti disponibili sono scaricati dalle posizioni specificate in /etc/apt/sources.list. Per esempio, quando si usa un archivio Debian, questo comando recupera e analizza i file Packages.gz, in modo da rendere disponibili informazioni sui pacchetti nuovi e quelli aggiornati. Si dovrebbe sempre fare un update prima di un upgrade o dist-upgrade. Notare che l'indicatore di avanzamento globale non è preciso perché è impossibile conoscere in anticipo la dimensione dei file degli indici dei pacchetti.

upgrade
    upgrade è usato per installare le versioni più recenti di tutti i pacchetti attualmente installati sul sistema, usando le fonti elencate in /etc/apt/sources.list. I pacchetti attualmente installati con nuove versioni disponibili sono recuperati e aggiornati; in nessun caso vengono rimossi pacchetti attualmente installati oppure recuperati e installati pacchetti che non lo sono già. I pacchetti attualmente installati che hanno una nuova versione, ma che non possono essere aggiornati senza cambiare lo stato di installazione di un altro pacchetto, vengono lasciati alla versione attuale. Deve essere prima effettuato un update in modo che apt-get sappia se sono disponibili nuove versioni dei pacchetti.

dist-upgrade
    dist-upgrade, oltre ad effettuare le funzioni di upgrade, gestisce anche in maniera intelligente le modifiche delle dipendenze delle nuove versioni dei pacchetti; apt-get ha un sistema «intelligente» di risoluzione dei conflitti e cerca di aggiornare i pacchetti più importanti a scapito di quelli meno importanti, se necessario. Il comando dist-upgrade può quindi rimuovere alcuni pacchetti. Il file /etc/apt/sources.list contiene un elenco di posizioni da cui recuperare i file di pacchetto desiderati. Vedere anche apt_preferences(5) per un meccanismo per scavalcare le impostazioni generali per singoli pacchetti.

dselect-upgrade
    dselect-upgrade viene usato insieme a dselect(1), il frontend tradizionale per i pacchetti di Debian. dselect-upgrade segue i cambiamenti fatti da dselect(1) al campo Status dei pacchetti disponibili, ed effettua le azioni necessarie per realizzare tale stato (ad esempio la rimozione di vecchi pacchetti e l'installazione di nuovi).

install
    install è seguito da uno o più pacchetti da installare o aggiornare. Ogni pacchetto è un nome di pacchetto, non un nome di file pienamente qualificato (ad esempio, in un sistema Debian, l'argomento fornito sarebbe apt-utils, non apt-utils_1.0.9.8.5_amd64.deb). Tutti i pacchetti richiesti dai pacchetti specificati per l'installazione saranno anch'essi recuperati e installati. Il file /etc/apt/sources.list viene usato per localizzare i pacchetti desiderati. Se viene aggiunto un segno meno alla fine del nome di pacchetto (senza spazio), il pacchetto specificato viene rimosso, se è installato. Analogamente un segno più può essere usato per specificare un pacchetto da installare. Queste ultime funzionalità possono essere usate per scavalcare decisioni prese dal sistema di risoluzione dei conflitti di apt-get.

    È possibile selezionare una versione specifica di un pacchetto per l'installazione scrivendo dopo il nome del pacchetto un segno di uguale e la versione del pacchetto da selezionare. Ciò farà sì che venga localizzata e selezionata per l'installazione quella versione. In alternativa può essere selezionata una distribuzione specifica scrivendo dopo il nome del pacchetto una sbarra («/») e la versione della distribuzione o il nome dell'archivio (stable, testing, unstable).

    Entrambi i meccanismi di selezione della versione possono far retrocedere pacchetti e devono essere usati con cautela.

    Questa è l'azione da usare anche quando si desiderano aggiornare uno o più pacchetti già installati senza aggiornare ogni pacchetto nel sistema. A differenza dell'azione «upgrade», che aggiorna alla versione più recente tutti i pacchetti installati, «install» installa la versione più recente solamente per i pacchetti specificati. Basta fornire il nome dei pacchetti che si desiderano aggiornare e, se è disponibile una versione più recente, essa (e tutte le sue dipendenze come descritto sopra) verrà scaricata e installata.

    Da ultimo, il meccanismo apt_preferences(5) permette di creare una politica di installazione alternativa per i singoli pacchetti.

    Se nessun pacchetto corrisponde all'espressione specificata e questa contiene uno tra «.», «?» o «*», allora viene considerata come un'espressione regolare POSIX e viene confrontata con tutti i nomi di pacchetto nel database. Ogni corrispondenza viene quindi installata (o rimossa). Notare che la corrispondenza avviene con sottostringhe, perciò «bass.*» trova corrispondenza con «quanto-bass» e «bassissimo». Se ciò non è quello che si desidera, ancorare l'espressione regolare con un carattere «^» o «$», oppure creare un'espressione regolare più specifica.

remove
    remove è identico a install tranne per il fatto che i pacchetti sono rimossi invece che installati. Notare che la rimozione di un pacchetto lascia i suoi file di configurazione nel sistema. Se viene aggiunto un segno più in fondo al nome del pacchetto (senza spazi in mezzo), il pacchetto specificato viene installato invece che rimosso.

purge
    purge è identico a remove tranne per il fatto che i pacchetti sono rimossi ed eliminati completamente (viene eliminato anche ogni file di configurazione).

source
    source fa sì che apt-get scarichi i pacchetti sorgente. APT esaminerà i pacchetti disponibili per decidere quali pacchetti sorgente scaricare. Poi, se possibile, troverà e scaricherà nella directory corrente la versione più recente disponibile di quel pacchetto sorgente rispettando il rilascio predefinito, impostato con l'opzione APT::Default-Release, l'opzione -t o per i singoli pacchetti con la sintassi pacch/rilascio.

    Il sistema tiene traccia dei pacchetti sorgente in modo separato dai pacchetti binari, attraverso righe deb-src nel file sources.list(5). Ciò significa che sarà necessario aggiungere una riga di questo tipo per ciascun repository da cui si desiderano ottenere sorgenti; in caso contrario probabilmente si otterrà la versione sorgente sbagliata (troppo vecchia o troppo nuova) oppure nessuna versione.

    Se viene specificata l'opzione --compile allora il pacchetto verrà compilato in un .deb binario usando dpkg-buildpackage per l'architettura così come definita dall'opzione --host-architecture. Se viene usata l'opzione --download-only, allora il pacchetto sorgente non verrà spacchettato.

    Può essere recuperata una specifica versione sorgente facendo seguire al nome del sorgente un segno uguale e quindi la versione da scaricare, in modo simile al meccanismo usato per i file di pacchetto. Ciò permette la corrispondenza esatta con il nome e la versione del pacchetto sorgente, abilitando implicitamente l'opzione APT::Get::Only-Source.

    Notare che i pacchetti sorgente non vengono installati né viene tenuta traccia di essi nel database di dpkg come per i pacchetti binari; sono semplicemente scaricati nella directory corrente, come archivi tar dei sorgenti.

build-dep
    build-dep fa sì che apt-get installi o rimuova pacchetti, nel tentativo di soddisfare le dipendenze di compilazione di un pacchetto sorgente. In modo predefinito sono soddisfatte le dipendenze per compilare il pacchetto in modo nativo. Se lo si desidera, è possibile invece specificare un'architettura ospite con l'opzione --host-architecture.

check
    check è uno strumento diagnostico; aggiorna la cache dei pacchetti e controlla la presenza di dipendenze non soddisfatte.

download
    download scarica il pacchetto binario specificato nella directory corrente.

clean
    clean ripulisce il repository locale dei file di pacchetto recuperati. Rimuove tutto da /var/cache/apt/archives/ e /var/cache/apt/archives/partial/, tranne il file di lock.

autoclean
    Come clean, autoclean ripulisce il repository locale dei file di pacchetto recuperati. La differenza sta nel fatto che rimuove solo i file di pacchetto che non possono più essere scaricati e sono per lo più inutili. Questo permette di mantenere una cache per un periodo lungo senza che cresca fuori controllo. Se l'opzione di configurazione APT::Clean-Installed è disabilitata, impedisce che vengano eliminati i pacchetti installati.

autoremove
    autoremove viene usato per rimuovere i pacchetti che sono stati installati automaticamente per soddisfare delle dipendenze per altri pacchetti e che non sono più necessari.

changelog
    changelog scarica il changelog di un pacchetto e lo visualizza usando sensible-pager. Il nome e la directory di base del server sono definiti nella variabile APT::Changelogs::Server (ad esempio packages.debian.org/changelogs[1] per Debian o changelogs.ubuntu.com/changelogs[2] per Ubuntu). In modo predefinito visualizza il changelog per la versione che è installata. Tuttavia si possono specificare le stesse opzioni del comando install.

OPZIONI

Tutte le opzioni a riga di comando si possono impostare usando il file di configurazione; le descrizioni indicano l'opzione da impostare. Per le opzioni booleane si può scavalcare il file di configurazione usando qualcosa come -f-, --no-f, -f=no o diverse altre varianti.

--no-install-recommends
    Non considerare i pacchetti raccomandati come una dipendenza per l'installazione. Voce di configurazione: APT::Install-Recommends.

--install-suggests
    Considera i pacchetti suggeriti come una dipendenza per l'installazione. Voce di configurazione:APT::Install-Suggests.

-d, --download-only
    Scarica solamente; i file di pacchetto sono solo recuperati e non spacchettati o installati. Voce di configurazione: APT::Get::Download-Only.

-f, --fix-broken
    Aggiusta; cerca di correggere un sistema che ha dipendenze non soddisfatte. Questa opzione, quando usata con install o remove, può omettere qualsiasi pacchetto per permettere ad APT di trovare una soluzione valida. Se sono specificati dei pacchetti, questi devono risolvere completamente il problema. L'opzione è a volte necessaria quando si esegue APT per la prima volta; APT stesso non permette l'esistenza di pacchetti con dipendenze non soddisfatte in un sistema. È possibile che la struttura di dipendenze di un sistema sia corrotta a tal punto da richiedere un intervento manuale (il che di solito significa usare dpkg --remove per eliminare alcuni dei pacchetti che creano problemi). L'uso di questa opzione insieme a -m può in alcune situazioni produrre un errore. Voce di configurazione: APT::Get::Fix-Broken.

-m, --ignore-missing, --fix-missing
    Ignora i pacchetti mancanti; se alcuni pacchetti non possono essere recuperati o fallisce il controllo sulla loro integrità dopo il recupero (file di pacchetto corrotti), mantiene bloccati tali pacchetti e gestisce il risultato. L'uso di questa opzione insieme a -f può produrre un errore in alcune situazioni. Se un pacchetto è selezionato per l'installazione (particolarmente se è indicato nella riga di comando) e non può essere scaricato verrà silenziosamente mantenuto invariato. Voce di configurazione: APT::Get::Fix-Missing.

--no-download
    Disabilita lo scaricamento dei pacchetti. È usato al meglio con --ignore-missing per forzare APT ad usare solo i .deb che ha già scaricato. Voce di configurazione: APT::Get::Download.

-q, --quiet
    Silenzioso; produce un output adatto alla registrazione, omettendo gli indicatori di avanzamento. L'uso di più «q» produce un output più silenzioso fino a un massimo di 2. Si può anche usare -q=n per impostare il livello di silenziosità a n, scavalcando il file di configurazione. Notare che il livello di silenziosità 2 implica -y; non si dovrebbe mai usare -qq senza un modificatore che non fa azioni come -d, --print-uris o -s, dato che APT potrebbe decidere di fare qualcosa di inatteso. Voce di configurazione: quiet.

-s, --simulate, --just-print, --dry-run, --recon, --no-act
    Nessuna azione; effettua una simulazione degli eventi che si verificherebbero, ma non cambia realmente il sistema. Voce di configurazione: APT::Get::Simulate.

    Le esecuzioni simulate effettuate da un utente disattivano automaticamente il lock (Debug::NoLocking) e se è impostata l'opzione APT::Get::Show-User-Simulation-Note (come predefinito), viene anche visualizzato un messaggio che indica che quella fatta è solo una simulazione. Le esecuzioni effettuate da root non attivano né NoLocking né i messaggi: i superutenti dovrebbero sapere ciò che stanno facendo senza bisogno di ulteriori avvertimenti da apt-get.

    Le esecuzioni simulate stampano una serie di righe, ciascuna delle quali rappresenta un'operazione di dpkg: configurazione (Conf), rimozione (Remv) o spacchettamento (Inst). Le parentesi quadre indicano i pacchetti difettosi e le parentesi quadre vuote indicano difetti che non hanno conseguenze (rari).

-y, --yes, --assume-yes
    Rispondi automaticamente «sì» ai prompt; assume «sì» come risposta a tutti i prompt e viene eseguito in modo non interattivo. Se si verifica una situazione non desiderabile, come il cambiamento di un pacchetto bloccato, il tentativo di installazione di un pacchetto non autenticato o la rimozione di un pacchetto essenziale, allora apt-get annullerà l'esecuzione. Voce di configurazione: APT::Get::Assume-Yes.

--assume-no
    Rispondi automaticamente «no» a tutti i prompt. Voce di configurazione: APT::Get::Assume-No.

-u, --show-upgraded
    Mostra i pacchetti aggiornati; stampa un elenco di tutti i pacchetti che devono essere aggiornati. Voce di configurazione: APT::Get::Show-Upgraded.

-V, --verbose-versions
    Mostra la versione completa dei pacchetti aggiornati e installati. Voce di configurazione: APT::Get::Show-Versions.

-a, --host-architecture
    Questa opzione controlla l'architettura per la quale apt-get source --compile compila i pacchetti e come le dipendenze di compilazione incrociata sono soddisfatte. In modo predefinito non è impostata, il che significa che l'architettura ospite è la stessa dell'architettura di compilazione (che è definita da APT::Architecture). Voce di configurazione: APT::Get::Host-Architecture.

-P, --build-profiles
    Questa opzione controlla i profili di compilazione attivi per i quali apt-get source --compile compila un pacchetto sorgente e come le dipendenze di compilazione sono soddisfatte. In modo predefinito non è attivo alcun profilo di compilazione. Più profili di compilazione possono essere attivati contemporaneamente concatenandoli con una virgola. Voce di configurazione: APT::Build-Profiles.

-b, --compile, --build
    Compila i pacchetti sorgente dopo averli scaricati. Voce di configurazione: APT::Get::Compile.

--ignore-hold
    Ignora i blocchi sui pacchetti; ciò fa sì che apt-get ignori il blocco posto su un pacchetto. Può essere utile insieme a dist-upgrade per scavalcare un grande numero di blocchi non desiderati. Voce di configurazione: APT::Ignore-Hold.

--with-new-pkgs
    Permette l'installazione di nuovi pacchetti quando usato insieme a upgrade. Ciò è utile se l'aggiornamento di un pacchetto installato richiede l'installazione di nuove dipendenze. Invece di bloccare il pacchetto upgrade aggiornerà il pacchetto e installerà le nuove dipendenze. Notare che upgrade con questa opzione non rimuoverà mai pacchetti, permetterà solo l'aggiunta di nuovi. Voce di configurazione: APT::Get::Upgrade-Allow-New.

--no-upgrade
    Non aggiornare i pacchetti; quando usato insieme a install, no-upgrade impedisce che i pacchetti nella riga di comando vengano aggiornati se sono già installati. Voce di configurazione: APT::Get::Upgrade.

--only-upgrade
    Non installare nuovi pacchetti; quando usato insieme a install, only-upgrade installa gli aggiornamenti solamente per i pacchetti già installati e ignora le richieste di installarne di nuovi. Voce di configurazione: APT::Get::Only-Upgrade.

--force-yes
    Forza «sì»; questa è un'opzione pericolosa che fa sì che apt, se sta facendo qualcosa di potenzialmente pericoloso, continui senza chiedere l'autorizzazione all'utente. Non dovrebbe essere usata se non in situazioni molto particolari. L'uso di force-yes può potenzialmente distruggere il sistema. Voce di configurazione: APT::Get::force-yes.

--print-uris
    Invece di scaricare i file per l'installazione, stampa i loro URI. Ogni URI ha il percorso, il nome del file di destinazione, la dimensione e l'hash MD5 atteso. Notare che il nome file in cui scrivere non corrisponde sempre al nome file sul sito remoto. Questo funziona anche con i comandi source e update. Quando usato con il comando update l'hash MD5 e la dimensione non sono inclusi, e sta all'utente decomprimere qualsiasi file compresso. Voce di configurazione: APT::Get::Print-URIs.

--purge
    Usa purge invece di remove per ogni cosa da rimuovere. Verrà visualizzato un asterisco («*») vicino ai pacchetti pianificati per l'eliminazione completa. remove --purge è equivalente al comando purge. Voce di configurazione: APT::Get::Purge.

--reinstall
    Reinstalla i pacchetti che sono già installati alla nuova versione. Voce di configurazione: APT::Get::ReInstall.

--list-cleanup
    Questa opzione è attivata in modo predefinito; usare --no-list-cleanup per disabilitarla. Quando è attivata apt-get gestisce automaticamente il contenuto di /var/lib/apt/lists per garantire che i file obsoleti siano eliminati. L'unica ragione per disabilitarla è se si cambia di frequente la propria lista di fonti. Voce di configurazione: APT::Get::List-Cleanup.

-t, --target-release, --default-release
    Questa opzione controlla l'input predefinito per il motore delle politiche; crea un pin predefinito alla priorità 990 usando la stringa di rilascio specificata. Ciò scavalca le impostazioni generali in /etc/apt/preferences. Questa opzione non ha effetto sui pacchetti su cui si usa specificatamente il pinning. In breve, questa opzione permette di avere un semplice controllo sulla distribuzione da cui verranno recuperati i pacchetti. Alcuni esempi comuni possono essere -t '2.1*', -t unstable o -t sid. Voce di configurazione: APT::Default-Release; vedere anche la pagina di manuale di apt_preferences(5).

--trivial-only
    Effettua solo le operazioni che sono «banali». Può essere correlato logicamente a --assume-yes: mentre --assume-yes risponde «sì» a tutti i prompt, --trivial-only risponde «no». Voce di configurazione: APT::Get::Trivial-Only.

--no-remove
    Se un qualsiasi pacchetto dovrebbe essere rimosso, apt-get immediatamente annulla l'operazione senza chiedere. Voce di configurazione: APT::Get::Remove.

--auto-remove
    Se il comando è install oppure remove, allora questa opzione si comporta come se si eseguisse il comando autoremove, rimuovendo i pacchetti di dipendenza non utilizzati. Voce di configurazione: APT::Get::AutomaticRemove.

--only-source
    Ha significato solo per i comandi source e build-dep. Indica che i nomi dei sorgenti indicati non devono essere mappati usando la tabella dei binari; ciò significa che, se viene specificata questa opzione, tali comandi accetteranno solamente nomi di pacchetti sorgente come argomento, invece di accettare nomi di pacchetti binari e cercare il pacchetto sorgente corrispondente. Voce di configurazione: APT::Get::Only-Source.

--diff-only, --dsc-only, --tar-only
    Scarica solo il file diff, dsc o tar di un archivio sorgente. Voce di configurazione: APT::Get::Diff-Only, APT::Get::Dsc-Only e APT::Get::Tar-Only.

--arch-only
    Elabora solo le dipendenze di compilazione dipendenti dall'architettura. Voce di configurazione: APT::Get::Arch-Only.

--allow-unauthenticated
    Ignora se i pacchetti non possono essere autenticati e non chiedere all'utente cosa fare. È utile per strumenti come pbuilder. Voce di configurazione: APT::Get::AllowUnauthenticated.

--show-progress
    Show user friendly progress information in the terminal window when packages are installed, upgraded or removed. For a machine parsable version of this data see README.progress-reporting in the apt doc directory. Configuration Item: Dpkg::Progress and Dpkg::Progress-Fancy.

-h, --help
    Mostra un breve riassunto sull'uso.

-v, --version
    Mostra la versione del programma.

-c, --config-file
    File di configurazione; specifica un file di configurazione da usare. Il programma legge il file di configurazione predefinito e poi questo file di configurazione. Se è necessario modificare le impostazioni di configurazione prima che vengano analizzati i file di configurazione predefiniti, specificare un file con la variabile d'ambiente APT_CONFIG. Vedere apt.conf(5) per informazioni sulla sintassi.

-o, --option
    Imposta un'opzione di configurazione; imposterà una qualunque opzione di configurazione. La sintassi è -o Pinco::Pallo=pallo. -o e --option si possono usare più volte per impostare opzioni diverse.

FILE

/etc/apt/sources.list
    Posizioni da cui scaricare i pacchetti. Voce di configurazione: Dir::Etc::SourceList.

/etc/apt/sources.list.d/
    Frammenti di file per le posizioni da cui scaricare i pacchetti. Voce di configurazione: Dir::Etc::SourceParts.

/etc/apt/apt.conf
    File di configurazione di APT. Voce di configurazione: Dir::Etc::Main.

/etc/apt/apt.conf.d/
    Frammenti di file di configurazione di APT. Voce di configurazione: Dir::Etc::Parts.

/etc/apt/preferences
    File di preferenze di versione. Qui si specifica il "pinning", ossia una preferenza a prendere determinati pacchetti da una fonte separata o da una diversa versione di una distribuzione. Voce di configurazione: Dir::Etc::Preferences.

/etc/apt/preferences.d/
    Frammenti di file per le preferenze di versione. Voce di configurazione: Dir::Etc::PreferencesParts.

/var/cache/apt/archives/
    Area di archiviazione per i file dei pacchetti recuperati. Voce di configurazione: Dir::Cache::Archives.

/var/cache/apt/archives/partial/
    Area di archiviazione per i file dei pacchetti in transito. Voce di configurazione: Dir::Cache::Archives (partial verrà implicitamente aggiunto in fondo al nome)

/var/lib/apt/lists/
    Area di archiviazione per le informazioni sullo stato di ciascuna risorsa dei pacchetti specificata in sources.list(5) Voce di configurazione: Dir::State::Lists.

/var/lib/apt/lists/partial/
    Area di archiviazione per le informazioni di stato in transito. Voce di configurazione: Dir::State::Lists (partial verrà implicitamente aggiunto in fondo al nome)

VEDERE ANCHE

apt-cache(8), apt-cdrom(8), dpkg(1), sources.list(5), apt.conf(5), apt-config(8), apt-secure(8), la guida dell'utente di APT in /usr/share/doc/apt-doc/, apt_preferences(5), l'APT Howto.

DIAGNOSTICA

apt-get restituisce zero in caso di funzionamento normale e il valore decimale 100 in caso di errore.

BUG

Pagina dei bug di APT[3]. Se si desidera segnalare un bug in APT, vedere /usr/share/doc/debian/bug-reporting.txt o il comando reportbug(1).

TRADUZIONE

Traduzione in italiano a cura del Team italiano di localizzazione di Debian <debian-l10n-italian@lists.debian.org>. In particolare hanno contribuito Eugenia Franzoni (2000), Hugh Hartmann (2000-2012), Gabriele Stilli (2012), Beatrice Torracca (2012).

Notare che questa versione tradotta del documento può contenere parti non tradotte. Ciò è voluto, per evitare di perdere contenuti quando la traduzione non è aggiornata rispetto all'originale.

AUTORI

Jason Gunthorpe

Team APT

NOTE

1.  packages.debian.org/changelogs
    http://packages.debian.org/changelogs

2.  changelogs.ubuntu.com/changelogs
    http://changelogs.ubuntu.com/changelogs

3.  Pagina dei bug di APT
    http://bugs.debian.org/src:apt